# From Imports
from typing import Callable, Any, Dict
from functools import wraps


class Error(Exception):
    pass


class noIfElse(Error):
    pass


class decorators:
    def __init__(self):
        pass

    def zoom(*args, **kwargs) -> Any:
        """
			Run a function
		"""

        def wrapper(func: Callable[..., Any]):
            func(*args, **kwargs)

        return wrapper

    def savitar(*args, **kwargs) -> Callable[..., Any]:
        """
			Run a function later
		"""

        def wrapper(func: Callable[..., Any]):
            @wraps(func)
            # This returns the function of the function, not the call of the function
            def wrapped():
                return func(*args, **kwargs)

            return wrapped

        return wrapper

    def godspeed(*args, **kwargs) -> Callable[..., Any]:
        """
			Run a function immediately with a condition
		"""

        def wrapper(func: Callable[..., Any]):
            if_else: Dict[str, Any] = {
                "_if": kwargs.pop("_if", None),
                "_else": kwargs.pop("_else", None),
            }
            if (
                if_else["_if"] is None
                or if_else["_else"] is None
            ):
                raise noIfElse(
                    "Sorry; no if condition and / or else command given."
                )

            newKwargs: Dict[str, Any] = {}

            for k, v in kwargs.items():
                if "gs" in k.split("_"):
                    exec(f"{k} = {v}")
                else:
                    newKwargs[k] = v

            if eval(if_else["_if"]):
                func(*args, **newKwargs)
            else:
                exec(if_else["_else"])

        return wrapper

    # A class decorator...?
